"""
Exercise 2.1 and 2.2
Spring School on Scientific Computing

"""

from methods import newton, bisection, newton_linesearch, newton_Rn
import numpy as np
import matplotlib.pyplot as plt

#%% 2.1(b) f(x) = cos(x)
    
fun = lambda x: np.cos(x)
dfun = lambda x: -np.sin(x)
maxiter = 1000
tol = 1e-9
x0 = 2.5
z = np.pi/2


x_new, it_new, fun_values_new = newton(fun,dfun,x0,maxiter,tol)
print('---------------------------------')
print('Newton')
print('Number of iterations: ', it_new)
print('Difference between exact and numerical solution')
print(np.abs(x_new-z))

# 2.1(c): plot the convergence behaviour in a semilogy plot
plt.figure()    
xticks = np.arange(0,it_new) 
# plot in a logplot 
plt.semilogy(np.abs(fun_values_new), linewidth=2, label='Newton')
plt.legend()
plt.xticks(xticks)                              # set xticks fontsize
plt.xlabel('Iterations')
plt.ylabel('|f(x_k)|')                          # set yticks
plt.show()

############################################################

# 2.2(a) Bisection
a,b = 0.5, 2.5

x_bi, it_bi, fun_values_bi = bisection(fun,a,b,tol)
print('---------------------------------')
print('Bisection')
print('Number of iterations: ', it_bi)
print('Difference between exact and numerical solution')
print(np.abs(x_bi-z))

# 2.2(b): plot the convergence behaviour in a semilogy plot
plt.figure()    
it = np.max([it_new, it_bi])
xticks = np.arange(0,it,2) 
# plot in a logplot 
plt.semilogy(np.abs(fun_values_new), linewidth=2, label='Newton')
plt.semilogy(np.abs(fun_values_bi), linewidth=2, label='Bisection')
plt.legend()
plt.xticks(xticks)                              # set xticks fontsize
plt.xlabel('Iterations')
plt.ylabel('|f(x_k)|')                          # set yticks
plt.show()



# 2.3: f_2(x) = atan(x), the zero is at 0
    
fun = lambda x: np.arctan(x)
tol = 1e-9
z = 0
a,b = -0.5, 2.5

x_bi, it_bi, values_bi = bisection(fun,a,b,tol)
print('---------------------------------')
print('2nd Example')
print('Bisection')
print('Difference between exact and numerical solution')
print(np.abs(x_bi-z))
print('Number of iterations')
print(it_bi)

dfun = lambda x: 1/(x**2 + 1)
maxiter = 1000
x0=2

x_new, it_new, values_new = newton(fun,dfun,x0,maxiter,tol)
print('---------------------------------')
print('Newton')
print('Difference between exact and numerical solution')
print(np.abs(x_new-z))
print('Number of iterations')
print(it_new)


# Exercise 2.4: Newton with line search

q=0.9


print('---------------------------------')
print('Newton with line search')
x_ls, it_ls, values_ls = newton_linesearch(fun,dfun,x0,q,maxiter,tol)
print('Difference between exact and numerical solution')
print(np.abs(x_ls-z))
print('Number of iterations')
print(it_ls)


# Exercise 2.5: Newton in Rn

   

# F = lambda x: np.array([4*x[0]-np.cos(x[0])+np.sin(x[1]), 
                          4*x[1]-np.cos(x[0])+2*np.sin(x[1])])

# J = lambda x: np.array([[4+np.sin(x[0]), np.cos(x[1])],
                            [np.sin(x[0]), 4+2*np.cos(x[1])]]) 

# maxiter = 50
# tol = 1e-9
# x0 = np.array([0,0])

# x, it, res_it = newton_Rn(F, J, x0, maxiter, tol)

# print('---------------------------------')
# print('Newton in Rn')
# print('Solution:', x)
# print('Norm of the residual')
# print(res_it[-1])
# print('Number of iterations')
# print(it)




